#ifndef __TOAST_LOGGER_CONFIGURATION__
#define __TOAST_LOGGER_CONFIGURATION__

#ifdef TOASTLOGGER_EXPORTS
#define TOASTLOGGER_API     __declspec(dllexport)
#else
#define TOASTLOGGER_API     __declspec(dllimport)
#endif

typedef enum _TOAST_SERVICE_ZONE
{
    TOAST_SERVICE_ZONE_ALPHA = 0,
    TOAST_SERVICE_ZONE_REAL = 1
} TOAST_SERVICE_ZONE;

typedef enum _TOAST_LANGUAGE_TYPE
{
    TOAST_LANGUAGE_ENGLISH = 1,
    TOAST_LANGUAGE_KOREAN = 2
} TOAST_LANGUAGE_TYPE;

namespace toast
{
    namespace logger
    {        
        class TOASTLOGGER_API ToastLoggerConfiguration
        {
        public:
            virtual const char* getProjectVersion() = 0;
            virtual void setProjectVersion(const char* projectVersion) = 0;
            virtual const char* getProjectKey() = 0;
            virtual void setProjectKey(const char* projectKey) = 0;
          
            virtual TOAST_SERVICE_ZONE getServiceZone() = 0;
            virtual void setServiceZone(TOAST_SERVICE_ZONE serviceZone) = 0;

            virtual bool enableCrashReporter() = 0;
            virtual void enableCrashReporter(bool enableCrashReporter) = 0;
            virtual bool enableCrashSilenceMode() = 0;
            virtual void enableCrashSilenceMode(bool enableCrashSilenceMode) = 0;
            virtual bool enableApplyGDPR() = 0;
            virtual void enableApplyGDPR(bool disableUserIdentificationFields) = 0;

            virtual void setCrashReporterMessage(TOAST_LANGUAGE_TYPE langType, const wchar_t* message) = 0;
            virtual void saveCrashReporterMessageToJson() = 0;
        };
    }
}

extern "C" TOASTLOGGER_API toast::logger::ToastLoggerConfiguration* GetToastLoggerConfiguration();
extern "C" TOASTLOGGER_API void DestroyToastLoggerConfiguration();


#endif  //__TOAST_LOGGER_CONFIGURATION__